
<?php

function Commande ($commande) {
//=============================
try {
  // On se connecte à MySQL
  if (gethostbyaddr($_SERVER['REMOTE_ADDR']) == 'localhost') {
    $bdd1 = new PDO('mysql:host=localhost;dbname=jass;charset=utf8','root','',array(PDO::ATTR_ERRMODE => PDO::ERRMODE_EXCEPTION));
    }
  else {
    $bdd1 = new PDO('mysql:host=borj.myd.infomaniak.com;dbname=borj_jass;charset=utf8','borj_sebastien','LE VOTRE',array(PDO::ATTR_ERRMODE => PDO::ERRMODE_EXCEPTION));
    }
  
  }
catch(Exception $e) {
  // En cas d'erreur, on affiche un message et on arrête tout
  die('Erreur : '.$e->getMessage());
  }

$date =date("Y-m-d H:i:s");
$req1 = $bdd1->prepare('INSERT INTO commandes ( Timestamp, Commande) VALUES (:Timestamp, :Commande)');
$req1->execute(array( 'Timestamp' => $date, 'Commande' => $commande ));
$req1->closeCursor();
} // Commande

function Compte_points($bdd) { //Compte les points
//============================
//echo "Phase 4";

  //Crée la classe "carte"
  class carte {
  //===========
    private $power=0;
    private $couleur ="";
    private $type= "";
    private $id= 0;
    private $joueur = 0;
    private $score =0;
    private $points =0;

    public function __construct($idcarte, $joueur, $atout, $couleur_tour){
      if (gethostbyaddr($_SERVER['REMOTE_ADDR']) == 'localhost') {
        $bdd = new PDO('mysql:host=localhost;dbname=jass;charset=utf8','root','',array(PDO::ATTR_ERRMODE => PDO::ERRMODE_EXCEPTION));
        }
      else {
        $bdd = new PDO('mysql:host=borj.myd.infomaniak.com;dbname=borj_jass;charset=utf8','borj_sebastien','LE VOTRE',array(PDO::ATTR_ERRMODE => PDO::ERRMODE_EXCEPTION));
        }
      $reponse = $bdd->prepare('SELECT * FROM cartes_partie1 WHERE id = ? ');
      $reponse->execute(array($idcarte));
      $donnees = $reponse->fetch();
      $reponse->closeCursor();
      $this->power = $donnees['power'];
      $this->type= $donnees['type'];

      if ($donnees['couleur']=='Coeur') { $this->couleur = 1;}
      else if($donnees['couleur']=='Pique') { $this->couleur = 2;}
      else if($donnees['couleur']=='Carreau') { $this->couleur = 3;}
      else if($donnees['couleur']=='Trèfle') { $this->couleur = 4;}
      $this->joueur = $joueur;

      //Définit le score
      if ($atout == $this->couleur) {
        if      ($this->type =='Six') {$this->score =10;}
        else if ($this->type =='Sept') {$this->score =11;}
        else if ($this->type =='Huit') {$this->score =12;}
        else if ($this->type =='Dix') {$this->score =13;}
        else if ($this->type =='Dame') {$this->score =14;}
        else if ($this->type =='Roi') {$this->score =15;}
        else if ($this->type =='As') {$this->score =16;}
        else if ($this->type =='Neuf') {$this->score =17;}
        else if ($this->type =='Valet') {$this->score =18;}
        }
      else if ($couleur_tour == $this->couleur) {
        if      ($this->type =='Six') {$this->score =1;}
        else if ($this->type =='Sept') {$this->score =2;}
        else if ($this->type =='Huit') {$this->score =3;}
        else if ($this->type =='Neuf') {$this->score =4;}
        else if ($this->type =='Dix') {$this->score =5;}
        else if ($this->type =='Valet') {$this->score =6;}
        else if ($this->type =='Dame') {$this->score =7;}
        else if ($this->type =='Roi') {$this->score =8;}
        else if ($this->type =='As') {$this->score =9;}
        }
      else {
        $this->score =0;
        }

      //On calcule les points des cartes
      if      ($this->type =='Six') {$this->points =0;}
      else if ($this->type =='Sept') {$this->points =0;}
      else if ($this->type =='Huit') {$this->points =0;}
      else if ($this->type =='Neuf') {
        if ($this->couleur == $atout) { $this->points = 14; }
        else { $this->points =0; }
        }
      else if ($this->type =='Dix') {$this->points =10;}
      else if ($this->type =='Valet') {
        if ($this->couleur == $atout) { $this->points = 20; }
        else { $this->points =2; }
        }
      else if ($this->type =='Dame') {$this->points =3;}
      else if ($this->type =='Roi') {$this->points =4;}
      else if ($this->type =='As') {$this->points =11;}
      } //constructeur

      public function couleur() { return $this->couleur; }
      public function points() {  return $this->points;  }
      public function joueur() {  return $this->joueur;  }
      public function score() {   return $this->score;   }

    } // class carte {

  //On regarde quel joueur a gagné
  $req = $bdd->prepare('SELECT Etat FROM etat_partie WHERE id = ?');
  //Récupère l'atout
  $req->execute(array(6));
  $donnees = $req->fetch();
  $atout = $donnees ['Etat'];
  //Récupère la couleur du tour
  $req->execute(array(7));
  $donnees = $req->fetch();
  $couleur_tour = $donnees ['Etat'];
  /*
  $req->execute(array(2));
  $donnees = $req->fetch();
  $nbr_phases = $donnees ['Etat'];
  */
  //récupère le nombre de plies
  $req->execute(array(16));
  $donnees = $req->fetch();
  $nbr_plies = $donnees ['Etat'];
  $req->closeCursor();
  $nbr_plies++;
  //Crée un objet pour la carte de chaque joueur
  $reponse = $bdd->prepare('SELECT ID_cartes, Joueur FROM cartes_jouees WHERE id = ? ');
  
  // On définit les objets "carte"
  $carte1 = 0;  $carte2 = 0;  $carte3 = 0;  $carte4 = 0; // Juste pour éviter un 'warning' de Netbeans qui pense que les cartes sont non définies.
  for ($i=1; $i <=4; $i++) {
    $reponse->execute(array($i));
    $donnees = $reponse->fetch();
    ${ 'carte' . $i } = new carte($donnees['ID_cartes'], $donnees['Joueur'],$atout,$couleur_tour);
    }
  $reponse->closeCursor();

  // Les objets  $carte1 à $carte4 sont défini dans la boucle 'for' ci-dessus
  $max_score= max($carte1->score(),$carte2->score(),$carte3->score(),$carte4->score()); //calcule quel joueur gagne
  if ($max_score==$carte1->score()) { $joueur_gagne = $carte1->joueur();}
  else if($max_score==$carte2->score()) { $joueur_gagne = $carte2->joueur();}
  else if($max_score==$carte3->score()) { $joueur_gagne = $carte3->joueur();}
  else if($max_score==$carte4->score()) { $joueur_gagne = $carte4->joueur();}
  //Détermine l'équipe gagnante
  if($joueur_gagne == 1 OR $joueur_gagne == 3) {$equipe_gagne =1;}
  else if($joueur_gagne == 2 OR $joueur_gagne == 4) {$equipe_gagne =2;}
  $req = $bdd->prepare('UPDATE etat_partie SET Etat = ? WHERE id = 4'); //Définit qui commence la prochaine plie
  $req->execute(array($joueur_gagne));
  $req->closeCursor();


  //On compte les points
  $points = $carte1->points() + $carte2->points() + $carte3->points() + $carte4->points();
  if ($equipe_gagne ==1) {
    $reponse = $bdd->query('SELECT Etat FROM etat_partie WHERE id = 9 ');
    $donnees =$reponse->fetch();
    $reponse->closeCursor();
    $points_old = $donnees['Etat'];
    $new_points = $points + $points_old;
    //Cinq de der
    if ($nbr_plies == 9) { $new_points+= 5; }
    //Met à jour les points
    $req = $bdd->prepare('UPDATE etat_partie SET Etat = ? WHERE id = 9'); // Met à jour les points de l'équipe
    $req->execute(array($new_points));
    $req->closeCursor();

    //Met à jour le numéro du match
    /*
    $req = $bdd->query('SELECT Etat FROM etat_partie WHERE id = 2 ');
    $num_match =$req->fetch()['Etat'];
    $req->closeCursor();
    $req = $bdd->prepare('UPDATE etat_partie SET Etat = ? WHERE id = 2');
    $req->execute(array($num_match + 1));
    $req->closeCursor(); */
    //Si une équipe a plus de 1000 points ->Fin de la partie
    if ($new_points >= 1000) { gagne_Partie(1, $bdd); }
  }
  else if ($equipe_gagne ==2) {
    $reponse = $bdd->query('SELECT Etat FROM etat_partie WHERE id = 10 ');
    $donnees =$reponse->fetch();
    $reponse->closeCursor();
    $points_old = $donnees['Etat'];
    $new_points = $points + $points_old;
    //Cinq de der
    if ($nbr_plies == 9) { $new_points+= 5; Commande("CNQ DE DER");}
    $req = $bdd->prepare('UPDATE etat_partie SET Etat = ? WHERE id = 10');
    $req->execute(array($new_points));
    $req->closeCursor();
    //Met à jour le numéro du match
    /*$req = $bdd->query('SELECT Etat FROM etat_partie WHERE id = 2 ');
    $num_match =$req->fetch()['Etat'];
    $req->closeCursor();
    $req = $bdd->prepare('UPDATE etat_partie SET Etat = ? WHERE id = 2');
    $req->execute(array($num_match + 1));
    $req->closeCursor();*/
    //Si une équipe a plus de 1000 points ->Fin de la partie
    if($new_points >= 1000) {
      gagne_Partie(2, $bdd);
    }
  }

  $req = $bdd->prepare('UPDATE etat_partie SET Etat = ? WHERE id = ?');

  //actualise le nombre de plies
  if ($nbr_plies == 9) {$req->execute(array(         0, 16));} // Remet à zéro le nombre de plies 16 == Nombre_plies
  else                 {$req->execute(array($nbr_plies, 16));} 
  $req->execute(array(3,3)); //Définit l'état "Jeu"
  $req->closeCursor();

  Commande("GAGNE_PLIE " . $joueur_gagne . " " . $points );

  //Si le match est terminé
  if ($nbr_plies == 9) {
    //Récupère les points de l'équipe 1
    $reponse = $bdd->query('SELECT Etat FROM etat_partie WHERE id = 9 ');
    $points_equipe_1 =$reponse->fetch()['Etat'];
    $reponse->closeCursor();
    //Récupère les points de l'équipe 2
    $reponse = $bdd->query('SELECT Etat FROM etat_partie WHERE id = 10 ');
    $points_equipe_2 =$reponse->fetch()['Etat'];
    $reponse->closeCursor();

    Commande("FIN_MATCH " . $points_equipe_1 . " " . $points_equipe_2 );

    //Met à jour le numéro du match
    $req = $bdd->query('SELECT Etat FROM etat_partie WHERE id = 2 ');
    $num_match =$req->fetch()['Etat'];
    $req->closeCursor();
    $req = $bdd->prepare('UPDATE etat_partie SET Etat = ? WHERE id = 2');
    $req->execute(array($num_match + 1));
    $req->closeCursor();



    //Met à jour le joueur qui fait l'atout
    $reponse = $bdd->query('SELECT Etat FROM etat_partie WHERE id = 5 ');
    $joueur_atout =$reponse->fetch()['Etat'];
    $reponse->closeCursor();
    $joueur_atout++;
    if($joueur_atout == 5) { $joueur_atout = 1;}
    $req = $bdd->prepare(' UPDATE etat_partie  SET Etat = ? WHERE id = 5');
    $req->execute(array($joueur_atout));
    $req->closeCursor();
    //Repasse en phase de jeu
    $bdd->exec(' UPDATE etat_partie  SET Etat = 1 WHERE id = 3');
    }
  else {
    Commande("TOUR " . $joueur_gagne);
    }  

// Vu que la fonction est longue, toutes les lignes ont été décalées.
} //Compte_points
  
function Annonce($bdd) {
//======================
//Récupère les cartes depuis la BDD par ordre de joueur: carte 0 à 8 -> j1, carte 9 à 17 -> j2 , etc
for($ii = 1; $ii <= 4; $ii++) {
  $req = $bdd->prepare('SELECT id FROM cartes_partie1 WHERE joueur = :joueur');
  $req->execute(array( 'joueur' => $ii));
  for($i =1; $i <= 9; $i++) {
    $tableau_cartes[] = (int) $req->fetch()['id'];
    }
  }

  $req->closeCursor();
  //Récupère l'atout
  $req = $bdd->prepare('SELECT Etat FROM etat_partie WHERE id = ?');
  $req->execute(array(6));
  $donnees = $req->fetch();
  $atout = $donnees ['Etat'];
  $req->closeCursor();
        
  //Calcules les annonces
  $z =0;
  for($ii = 1; $ii <= 4; $ii++) { //Calcule les annonces des joueurs
    $annonce[$ii] = array(); //annonces du joueur $ii
    $valeur_annonce[$ii] = array(); //Valeur des annonces Ex: 4 rois -> 100 points
    //Variables annonces 4x même carte
    $nel = 0;
    $dix =0;
    $valet = 0;
    $dame =0;
    $roi=0;
    $as=0;
    //Variables annonces séries
    $coeur[$ii] = array();
    $pique[$ii] = array();
    $carreau[$ii] = array();
    $trefle[$ii] = array();
    for($i =1; $i <= 9; $i++) { //Parcourt les cartes de chaque joueur
      //Annonces 4x même carte
      if($tableau_cartes[$z] == 4 OR $tableau_cartes[$z] == 13 OR $tableau_cartes[$z] == 22 OR $tableau_cartes[$z] == 31 ) {
      $nel++;
        if($nel == 4) {
          $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 150;
          $annonce[$ii][sizeof($annonce[$ii]) + 1] = array(4,13,22,31);
          }
      }
      else if($tableau_cartes[$z] == 5 OR $tableau_cartes[$z] == 14 OR $tableau_cartes[$z] == 23 OR $tableau_cartes[$z] == 32 ) {
      $dix++;
      if($dix == 4) {
          $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 100;
          $annonce[$ii][sizeof($annonce[$ii]) + 1] = array(5,14,23,32);
          }
      }
      else if($tableau_cartes[$z] == 6 OR $tableau_cartes[$z] == 15 OR $tableau_cartes[$z] == 24 OR $tableau_cartes[$z] == 33 ) {
      $valet++;
      if($valet == 4) {
          $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 200;
          $annonce[$ii][sizeof($annonce[$ii]) + 1] = array(6,15,24,33);
          }
      }
      else if($tableau_cartes[$z] == 4 OR $tableau_cartes[$z] == 16 OR $tableau_cartes[$z] == 25 OR $tableau_cartes[$z] == 34 ) {
      $dame++;
      if($dame == 4) {
          $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 100;
          $annonce[$ii][sizeof($annonce[$ii]) + 1] = array(7,17,25,34);
          }
      }
      else if($tableau_cartes[$z] == 4 OR $tableau_cartes[$z] == 17 OR $tableau_cartes[$z] == 26 OR $tableau_cartes[$z] == 35 ) {
      $roi++;
      if($roi == 4) {
          $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 100;
          $annonce[$ii][sizeof($annonce[$ii]) + 1] = array(8,18,26,35);
          }
      }
      else if($tableau_cartes[$z] == 4 OR $tableau_cartes[$z] == 18 OR $tableau_cartes[$z] == 27 OR $tableau_cartes[$z] == 36 ) {
      $as++;
      if($as == 4) {
          $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 100;
          $annonce[$ii][sizeof($annonce[$ii]) + 1] = array(9,19,27,36);
          }
      }
      
      //Compte nombre cartes d'une couleur
      if($tableau_cartes[$z] <= 9) {
        
        $coeur[$ii][sizeof($coeur[$ii]) +1] = $tableau_cartes[$z];
      }
      elseif($tableau_cartes[$z] > 9 AND $tableau_cartes[$z] <= 18) {
        
        $pique[$ii][sizeof($pique[$ii]) +1] = $tableau_cartes[$z];
      }
      elseif($tableau_cartes[$z] > 18 AND $tableau_cartes[$z] <=27) {
        
        $carreau[$ii][sizeof($carreau[$ii]) +1] = $tableau_cartes[$z];
      }
      elseif($tableau_cartes[$z] > 27) {
        
        $trefle[$ii][sizeof($trefle[$ii]) +1] = $tableau_cartes[$z];
      }
      
      
        
    $z++;
    }
    
    $last_valeur = -1;
    $serie_coeur = 0;
    if(sizeof($coeur[$ii]) >= 3) { //Si il y a une annonce de 3 cartes ou plus
      foreach ($coeur[$ii] as $valeur) {
      
        if($last_valeur + 1 == $valeur) { // Si deux cartes se suivent
          $serie_coeur++;
          //echo "hello";
          //echo $serie_coeur;
        }
        elseif( $serie_coeur == 0 ) { //Si c'est le premier coeur d'une série
        $serie_coeur++;
        //echo "helloworld";
        //echo $serie_coeur;
        }
        else { //Si deux cartes ne se suivent pas, on calcule la valeur de l'annonce
          
          if($serie_coeur == 3) { //Si 3 cartes se suivent
            $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-2,$last_valeur-1, $last_valeur];
            $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 20;
            $serie_coeur = 0;
            //echo "hello";
          }
          else if($serie_coeur == 4) {
            $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-3,$last_valeur-2,$last_valeur-1, $last_valeur];
            $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 50;
            $serie_coeur = 0;
          }
          else if($serie_coeur >= 5 AND $serie_coeur <= 7) {
            $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-4,$last_valeur-3,$last_valeur-2,$last_valeur-1, $last_valeur];
            $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 100;
            $serie_coeur = 0;
          }
          else if($serie_coeur == 8) { // 5 et 3 cartes
          $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-4,$last_valeur-3,$last_valeur-2,$last_valeur-1, $last_valeur];
          $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 100;
          $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-7,$last_valeur-6, $last_valeur-5];
          $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 20;
            $serie_coeur = 0;
          }
          else if($serie_coeur == 9) { // 5 et 4 cartes
          $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-4,$last_valeur-3,$last_valeur-2,$last_valeur-1, $last_valeur];
          $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 100;
          $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-8,$last_valeur-7,$last_valeur-6, $last_valeur-5];
          $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 50;
            $serie_coeur = 0;
          }
          else {
            $serie_coeur =0;
          }
      }
      $last_valeur = $valeur;
    }
  }
    //Si la dernière carte faisait partie d'une annonce
    if($serie_coeur >= 3) {
              if($serie_coeur == 3) { //Si 3 cartes se suivent
            $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-2,$last_valeur-1, $last_valeur];
            $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 20;
            $serie_coeur = 0;
            
          }
          else if($serie_coeur == 4) {
            $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-3,$last_valeur-2,$last_valeur-1, $last_valeur];
            $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 50;
            $serie_coeur = 0;
          }
          else if($serie_coeur >= 5 AND $serie_coeur <= 7) {
            $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-4,$last_valeur-3,$last_valeur-2,$last_valeur-1, $last_valeur];
            $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 100;
            $serie_coeur = 0;
          }
          else if($serie_coeur == 8) { // 5 et 3 cartes
          $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-4,$last_valeur-3,$last_valeur-2,$last_valeur-1, $last_valeur];
          $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 100;
          $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-7,$last_valeur-6, $last_valeur-5];
          $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 20;
            $serie_coeur = 0;
          }
          else if($serie_coeur == 9) { // 5 et 4 cartes
          $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-4,$last_valeur-3,$last_valeur-2,$last_valeur-1, $last_valeur];
          $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 100;
          $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-8,$last_valeur-7,$last_valeur-6, $last_valeur-5];
          $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 50;
            $serie_coeur = 0;
          }  
    }
    $last_valeur = -1;
    $serie_pique = 0;
    if(sizeof($pique[$ii]) >= 3)  //Si il y a une annonce de 3 cartes ou plus
    {
      
    foreach ($pique[$ii] as $valeur) {
      
        if($last_valeur + 1 == $valeur) { // Si deux cartes se suivent
          $serie_pique++;
          
        }
        elseif( $serie_pique == 0 ) { //Si c'est le premier pique d'une série
        $serie_pique++;
        
        }
        else { //Si deux cartes ne se suivent pas, on calcule la valeur de l'annonce
          
          if($serie_pique == 3) { //Si 3 cartes se suivent
            $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-2,$last_valeur-1, $last_valeur];
            $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 20;
            $serie_pique = 0;
            
          }
          else if($serie_pique == 4) {
            $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-3,$last_valeur-2,$last_valeur-1, $last_valeur];
            $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 50;
            $serie_pique = 0;
          }
          else if($serie_pique >= 5 AND $serie_pique <= 7) {
            $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-4,$last_valeur-3,$last_valeur-2,$last_valeur-1, $last_valeur];
            $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 100;
            $serie_pique = 0;
          }
          else if($serie_pique == 8) { // 5 et 3 cartes
          $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-4,$last_valeur-3,$last_valeur-2,$last_valeur-1, $last_valeur];
          $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 100;
          $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-7,$last_valeur-6, $last_valeur-5];
          $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 20;
            $serie_pique = 0;
          }
          else if($serie_pique == 9) { // 5 et 4 cartes
          $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-4,$last_valeur-3,$last_valeur-2,$last_valeur-1, $last_valeur];
          $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 100;
          $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-8,$last_valeur-7,$last_valeur-6, $last_valeur-5];
          $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 50;
            $serie_pique = 0;
          }
          else {
            $serie_pique =0;
          }
      }
      $last_valeur = $valeur;
    }
  }
    //Si la dernière carte faisait partie d'une annonce
    if($serie_pique >= 3) {
              if($serie_pique == 3) { //Si 3 cartes se suivent
            $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-2,$last_valeur-1, $last_valeur];
            $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 20;
            $serie_pique = 0;
            
          }
          else if($serie_pique == 4) {
            $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-3,$last_valeur-2,$last_valeur-1, $last_valeur];
            $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 50;
            $serie_pique = 0;
          }
          else if($serie_pique >= 5 AND $serie_pique <= 7) {
            $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-4,$last_valeur-3,$last_valeur-2,$last_valeur-1, $last_valeur];
            $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 100;
            $serie_pique = 0;
          }
          else if($serie_pique == 8) { // 5 et 3 cartes
          $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-4,$last_valeur-3,$last_valeur-2,$last_valeur-1, $last_valeur];
          $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 100;
          $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-7,$last_valeur-6, $last_valeur-5];
          $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 20;
            $serie_pique = 0;
          }
          else if($serie_pique == 9) { // 5 et 4 cartes
          $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-4,$last_valeur-3,$last_valeur-2,$last_valeur-1, $last_valeur];
          $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 100;
          $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-8,$last_valeur-7,$last_valeur-6, $last_valeur-5];
          $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 50;
            $serie_pique = 0;
          }  
    }
        $last_valeur = -1;
    $serie_carreau = 0;
    if(sizeof($carreau[$ii]) >= 3)  //Si il y a une annonce de 3 cartes ou plus
    {
      
    foreach ($carreau[$ii] as $valeur) {
      
        if($last_valeur + 1 == $valeur) { // Si deux cartes se suivent
          $serie_carreau++;
          
        }
        elseif( $serie_carreau == 0 ) { //Si c'est le premier carreau d'une série
        $serie_carreau++;
        
        }
        else { //Si deux cartes ne se suivent pas, on calcule la valeur de l'annonce
          
          if($serie_carreau == 3) { //Si 3 cartes se suivent
            $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-2,$last_valeur-1, $last_valeur];
            $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 20;
            $serie_carreau = 0;
            
          }
          else if($serie_carreau == 4) {
            $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-3,$last_valeur-2,$last_valeur-1, $last_valeur];
            $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 50;
            $serie_carreau = 0;
          }
          else if($serie_carreau >= 5 AND $serie_carreau <= 7) {
            $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-4,$last_valeur-3,$last_valeur-2,$last_valeur-1, $last_valeur];
            $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 100;
            $serie_carreau = 0;
          }
          else if($serie_carreau == 8) { // 5 et 3 cartes
          $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-4,$last_valeur-3,$last_valeur-2,$last_valeur-1, $last_valeur];
          $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 100;
          $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-7,$last_valeur-6, $last_valeur-5];
          $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 20;
            $serie_carreau = 0;
          }
          else if($serie_carreau == 9) { // 5 et 4 cartes
          $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-4,$last_valeur-3,$last_valeur-2,$last_valeur-1, $last_valeur];
          $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 100;
          $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-8,$last_valeur-7,$last_valeur-6, $last_valeur-5];
          $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 50;
            $serie_carreau = 0;
          }
          else {
            $serie_carreau =0;
          }
      }
      $last_valeur = $valeur;
    }
  }
    //Si la dernière carte faisait partie d'une annonce
    if($serie_carreau >= 3) {
              if($serie_carreau == 3) { //Si 3 cartes se suivent
            $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-2,$last_valeur-1, $last_valeur];
            $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 20;
            $serie_carreau = 0;
            
          }
          else if($serie_carreau == 4) {
            $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-3,$last_valeur-2,$last_valeur-1, $last_valeur];
            $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 50;
            $serie_carreau = 0;
          }
          else if($serie_carreau >= 5 AND $serie_carreau <= 7) {
            $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-4,$last_valeur-3,$last_valeur-2,$last_valeur-1, $last_valeur];
            $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 100;
            $serie_carreau = 0;
          }
          else if($serie_carreau == 8) { // 5 et 3 cartes
          $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-4,$last_valeur-3,$last_valeur-2,$last_valeur-1, $last_valeur];
          $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 100;
          $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-7,$last_valeur-6, $last_valeur-5];
          $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 20;
            $serie_carreau = 0;
          }
          else if($serie_carreau == 9) { // 5 et 4 cartes
          $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-4,$last_valeur-3,$last_valeur-2,$last_valeur-1, $last_valeur];
          $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 100;
          $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-8,$last_valeur-7,$last_valeur-6, $last_valeur-5];
          $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 50;
            $serie_carreau = 0;
          }
            
    }
        $last_valeur = -1;
    $serie_trefle = 0;
    //var_dump($annonce[2]);
    if(sizeof($trefle[$ii]) >= 3)  //Si il y a une annonce de 3 cartes ou plus
    {

    foreach ($trefle[$ii] as $valeur) {
      
        if($last_valeur + 1 == $valeur) { // Si deux cartes se suivent
          $serie_trefle++;
          
        
          
        }
        elseif( $serie_trefle == 0 ) { //Si c'est le premier trefle d'une série
        $serie_trefle++;
      
        
        }
        else { //Si deux cartes ne se suivent pas, on calcule la valeur de l'annonce
          
          
          if($serie_trefle == 3) { //Si 3 cartes se suivent
            $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-2,$last_valeur-1, $last_valeur];
            $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 20;
            $serie_trefle = 0;
            
          }
          else if($serie_trefle == 4) {
            $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-3,$last_valeur-2,$last_valeur-1, $last_valeur];
            $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 50;
            $serie_trefle = 0;
          }
          else if($serie_trefle >= 5 AND $serie_trefle <= 7) {
            $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-4,$last_valeur-3,$last_valeur-2,$last_valeur-1, $last_valeur];
            $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 100;
            $serie_trefle = 0;
          }
          else if($serie_trefle == 8) { // 5 et 3 cartes
          $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-4,$last_valeur-3,$last_valeur-2,$last_valeur-1, $last_valeur];
          $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 100;
          $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-7,$last_valeur-6, $last_valeur-5];
          $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 20;
            $serie_trefle = 0;
          }
          else if($serie_trefle == 9) { // 5 et 4 cartes
          $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-4,$last_valeur-3,$last_valeur-2,$last_valeur-1, $last_valeur];
          $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 100;
          $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-8,$last_valeur-7,$last_valeur-6, $last_valeur-5];
          $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 50;
            $serie_trefle = 0;
          }
          else {
            $serie_trefle =0;
          }
        }
      
      $last_valeur = $valeur;
    }
  }
    //Si la dernière carte faisait partie d'une annonce
    if($serie_trefle >= 3) {
              if($serie_trefle == 3) { //Si 3 cartes se suivent
            $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-2,$last_valeur-1, $last_valeur];
            $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 20;
            $serie_trefle = 0;

          }
          else if($serie_trefle == 4) {
            $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-3,$last_valeur-2,$last_valeur-1, $last_valeur];
            $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 50;
            $serie_trefle = 0;
          }
          else if($serie_trefle >= 5 AND $serie_trefle <= 7) {
            $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-4,$last_valeur-3,$last_valeur-2,$last_valeur-1, $last_valeur];
            $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 100;
            $serie_trefle = 0;
          }
          else if($serie_trefle == 8) { // 5 et 3 cartes
          $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-4,$last_valeur-3,$last_valeur-2,$last_valeur-1, $last_valeur];
          $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 100;
          $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-7,$last_valeur-6, $last_valeur-5];
          $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 20;
            $serie_trefle = 0;
          }
          else if($serie_trefle == 9) { // 5 et 4 cartes
          $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-4,$last_valeur-3,$last_valeur-2,$last_valeur-1, $last_valeur];
          $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 100;
          $annonce[$ii][sizeof($annonce[$ii]) + 1] = [$last_valeur-8,$last_valeur-7,$last_valeur-6, $last_valeur-5];
          $valeur_annonce[$ii][sizeof($valeur_annonce[$ii]) + 1] = 50;
            $serie_trefle = 0;
          }  
    }
  
//Détermine l'annonce la plus forte de chaque joueur
    $max_annonce[$ii] = [0,0]; //[valeur de l'annonce , numéro de l'annonce]
    //var_dump($max_annonce[1]);
    $numero_annonce = 1;
  foreach ($valeur_annonce[$ii] as $valeur) {
    if ($valeur > $max_annonce[$ii][0]) {
      $max_annonce[$ii] = [$valeur, $numero_annonce]; 
      }
    elseif( $valeur == $max_annonce[$ii][0] AND $valeur != 0) { //Si deux annonces valent autant de points

        if( sizeof($annonce[$ii][$numero_annonce]) > sizeof($annonce[$ii][$max_annonce[$ii][1]]) ) { //Si l'annonce a plus de cartes
          $max_annonce[$ii] = [$valeur, $numero_annonce];
        }
        elseif(sizeof($annonce[$ii][$numero_annonce]) == sizeof($annonce[$ii][$max_annonce[$ii][1]])) {
          //Si les deux annonces ont le même nombre de cartes, l'annonce avec la carte la plus haute gagne
          $meilleure_carte = [end($annonce[$ii][$numero_annonce]), end($annonce[$ii][$max_annonce[$ii][1]])]; //Numéro de la carte la plus haute
          $ordre_annonce = 0; //ancienne ou nouvelle annonce
          foreach($meilleure_carte as $valeur_carte ) {
            if ($valeur_carte == 1 OR $valeur_carte == 10 OR $valeur_carte == 19 OR $valeur_carte == 28 ){ $meilleure_carte_valeur[$ordre_annonce] = 1;}
            elseif ($valeur_carte == 2 OR $valeur_carte == 11 OR $valeur_carte == 20 OR $valeur_carte == 29 ){ $meilleure_carte_valeur[$ordre_annonce] = 2;}
            elseif ($valeur_carte == 3 OR $valeur_carte == 12 OR $valeur_carte == 21 OR $valeur_carte == 30 ){ $meilleure_carte_valeur[$ordre_annonce] = 3;}
            elseif ($valeur_carte == 4 OR $valeur_carte == 13 OR $valeur_carte == 22 OR $valeur_carte == 31 ){ $meilleure_carte_valeur[$ordre_annonce] = 4;}
            elseif ($valeur_carte == 5 OR $valeur_carte == 14 OR $valeur_carte == 23 OR $valeur_carte == 32 ){ $meilleure_carte_valeur[$ordre_annonce] = 5;}
            elseif ($valeur_carte == 6 OR $valeur_carte == 15 OR $valeur_carte == 24 OR $valeur_carte == 33 ){ $meilleure_carte_valeur[$ordre_annonce] = 6;}
            elseif ($valeur_carte == 7 OR $valeur_carte == 16 OR $valeur_carte == 25 OR $valeur_carte == 34 ){ $meilleure_carte_valeur[$ordre_annonce] = 7;}
            elseif ($valeur_carte == 8 OR $valeur_carte == 17 OR $valeur_carte == 26 OR $valeur_carte == 35 ){ $meilleure_carte_valeur[$ordre_annonce] = 8;}
            elseif ($valeur_carte == 9 OR $valeur_carte == 18 OR $valeur_carte == 27 OR $valeur_carte == 36 ){ $meilleure_carte_valeur[$ordre_annonce] = 9;}
            
            $ordre_annonce++;
          }
          if($meilleure_carte_valeur[0] > $meilleure_carte_valeur[1]) { //Si la nouvelle annonce a une carte plus grande que l'ancienne
            $max_annonce[$ii] = [$valeur, $numero_annonce];
          }
          elseif($meilleure_carte_valeur[0] == $meilleure_carte_valeur[1]) {
            //Si la nouvelle annonce a la même carte que l'ancienne, celle qui est un atout l'emporte
            
              $meilleure_carte_atout = [end($annonce[$ii][$numero_annonce]), end($annonce[$ii][$max_annonce[$ii][1]])]; //Numéro de la carte la plus haute
          $ordre_annonce = 0; //ancienne ou nouvelle annonce
          foreach($meilleure_carte_atout as $valeur_carte ) { //Détermine la couleur de la carte
            if ($valeur_carte <=9 ){ $meilleure_carte_atout_valeur[$ordre_annonce] = 1;}
            elseif ($valeur_carte <= 18 AND $valeur_carte > 9 ){ $meilleure_carte_atout_valeur[$ordre_annonce] = 2;}
            elseif ($valeur_carte <= 27 AND $valeur_carte > 18 ){ $meilleure_carte_atout_valeur[$ordre_annonce] = 3;}
            elseif ($valeur_carte > 27 ){ $meilleure_carte_atout_valeur[$ordre_annonce] = 4;}
            $ordre_annonce++;
          }
            if($meilleure_carte_atout_valeur[0] == $atout) { //Si la nouvelle annonce est un atout
              $max_annonce[$ii] = [$valeur, $numero_annonce];
              
            }
          }
          
        }
      }
    $numero_annonce++;
  }
  }
   
   //Détermine le joueur qui remporte l'annonce
   $annonce_gagnante= [0,0]; //[points de l'annonce, joueur]
   for($ii = 1; $ii <= 4; $ii++) {
     
     if($max_annonce[$ii][0] > $annonce_gagnante[0])
     {
       $annonce_gagnante = [$max_annonce[$ii][0] , $ii];
     }
     elseif($max_annonce[$ii][0] == $annonce_gagnante[0] AND $max_annonce[$ii][0] != 0) {

        if( sizeof($annonce[$ii][$max_annonce[$ii][1]]) > sizeof($annonce[$annonce_gagnante[1]][$max_annonce[$annonce_gagnante[1]][1]]) ) { //Si l'annonce a plus de cartes
          $annonce_gagnante = [$max_annonce[$ii][0], $ii];
        }
        elseif(sizeof($annonce[$ii][$max_annonce[$ii][1]]) == sizeof($annonce[$annonce_gagnante[1]][$max_annonce[$annonce_gagnante[1]][1]])) {
          //Si les deux annonces ont le même nombre de cartes, l'annonce avec la carte la plus haute gagne
          $meilleure_carte = [end($annonce[$ii][$max_annonce[$ii][1]]), end($annonce[$annonce_gagnante[1]][$max_annonce[$annonce_gagnante[1]][1]])]; //Numéro de la carte la plus haute
          $ordre_annonce = 0; //ancienne ou nouvelle annonce
          foreach($meilleure_carte as $valeur_carte ) {
            if ($valeur_carte == 1 OR $valeur_carte == 10 OR $valeur_carte == 19 OR $valeur_carte == 28 ){ $meilleure_carte_valeur[$ordre_annonce] = 1;}
            elseif ($valeur_carte == 2 OR $valeur_carte == 11 OR $valeur_carte == 20 OR $valeur_carte == 29 ){ $meilleure_carte_valeur[$ordre_annonce] = 2;}
            elseif ($valeur_carte == 3 OR $valeur_carte == 12 OR $valeur_carte == 21 OR $valeur_carte == 30 ){ $meilleure_carte_valeur[$ordre_annonce] = 3;}
            elseif ($valeur_carte == 4 OR $valeur_carte == 13 OR $valeur_carte == 22 OR $valeur_carte == 31 ){ $meilleure_carte_valeur[$ordre_annonce] = 4;}
            elseif ($valeur_carte == 5 OR $valeur_carte == 14 OR $valeur_carte == 23 OR $valeur_carte == 32 ){ $meilleure_carte_valeur[$ordre_annonce] = 5;}
            elseif ($valeur_carte == 6 OR $valeur_carte == 15 OR $valeur_carte == 24 OR $valeur_carte == 33 ){ $meilleure_carte_valeur[$ordre_annonce] = 6;}
            elseif ($valeur_carte == 7 OR $valeur_carte == 16 OR $valeur_carte == 25 OR $valeur_carte == 34 ){ $meilleure_carte_valeur[$ordre_annonce] = 7;}
            elseif ($valeur_carte == 8 OR $valeur_carte == 17 OR $valeur_carte == 26 OR $valeur_carte == 35 ){ $meilleure_carte_valeur[$ordre_annonce] = 8;}
            elseif ($valeur_carte == 9 OR $valeur_carte == 18 OR $valeur_carte == 27 OR $valeur_carte == 36 ){ $meilleure_carte_valeur[$ordre_annonce] = 9;}
            $ordre_annonce++;
            
          }
          if($meilleure_carte_valeur[0] > $meilleure_carte_valeur[1]) { //Si la nouvelle annonce a une carte plus grande que l'ancienne
            $annonce_gagnante = [$max_annonce[$ii][0] , $ii];
          }
          elseif($meilleure_carte_valeur[0] == $meilleure_carte_valeur[1]) {
            //Si la nouvelle annonce a la même carte que l'ancienne, celle qui est un atout l'emporte
            
              $meilleure_carte_atout = [end($annonce[$ii][$max_annonce[$ii][0]]), end($annonce[$annonce_gagnante[1]][$max_annonce[$annonce_gagnante[1]][1]])]; //Numéro de la carte la plus haute
          $ordre_annonce = 0; //ancienne ou nouvelle annonce
          foreach($meilleure_carte_atout as $valeur_carte ) { //Détermine la couleur de la carte
            if ($valeur_carte <=9 ){ $meilleure_carte_atout_valeur[$ordre_annonce] = 1;}
            elseif ($valeur_carte <= 18 AND $valeur_carte > 9 ){ $meilleure_carte_atout_valeur[$ordre_annonce] = 2;}
            elseif ($valeur_carte <= 27 AND $valeur_carte > 18 ){ $meilleure_carte_atout_valeur[$ordre_annonce] = 3;}
            elseif ($valeur_carte > 27 ){ $meilleure_carte_atout_valeur[$ordre_annonce] = 4;}
            $ordre_annonce++;
          }
            if($meilleure_carte_atout_valeur[0] == $atout) { //Si la nouvelle annonce est un atout
              $annonce_gagnante = [$max_annonce[$ii][0] , $ii];
              
            }
          }
          
        }
      }
  }

  //Compte les points des annonces
  if ($annonce_gagnante[0] > 0) {
     Commande("ANNONCEGAGNANTE " . $annonce_gagnante[1]);
     $ii = 1;
     $total_points = 0;
     $commande = "$annonce_gagnante[1] ";

     foreach($valeur_annonce[$annonce_gagnante[1]] as $points) {
      $total_points += $points;
      $commande .= "($points:";

      foreach ($annonce[$annonce_gagnante[1]][$ii] as $cartes)  {
        $commande .= "$cartes-";
        }

      $ii++;
      }

    if($annonce_gagnante[1] == 1) {
       $partenaire = 3; // partenaire du joueur gagnant
       $equipe = 1;
       }
     elseif($annonce_gagnante[1] == 2) {
       $partenaire = 4;
       $equipe= 2;
       }
     elseif($annonce_gagnante[1] == 3) {
       $partenaire = 1;
       $equipe= 1;
       }
     elseif($annonce_gagnante[1] == 4) {
       $partenaire = 2;
      $equipe= 2;
       }

     if (isset($valeur_annonce[$partenaire][1])) { //Si le partenaire a une annonce
      $ii = 1;
      $commande .= " $partenaire ";
      foreach ($valeur_annonce[$partenaire] as $points) {
        $total_points += $points;
        $commande .= "($points:";
        foreach ($annonce[$partenaire][$ii] as $cartes) { $commande .= "$cartes-"; }
        $ii++;
        }
      }
     //Récupère les points
     $req = $bdd->prepare('SELECT Etat FROM etat_partie WHERE id = ? ');
             $req->execute(array(8 + $equipe));
            $points_old =$req->fetch()['Etat'];
            $req->closeCursor();
    //met à jour les points
    $req = $bdd->prepare('UPDATE etat_partie SET Etat = ? WHERE id = ?');
          $req->execute(array($points_old + $total_points, 8 + $equipe));
          $req->closeCursor();
     Commande("ANNONCE " . $commande);
   }
} // Annonce

function gagne_Partie($equipe_gagnante, $bdd) {
//=============================================
$req= $bdd->prepare('SELECT Etat from etat_partie WHERE id = ?');
$req->execute(array(9));
$points_equipe_1= $req->fetch()['Etat'];
$req->execute(array(10));
$points_equipe_2= $req->fetch()['Etat'];
$req->closeCursor();

Commande("FIN_PARTIE " . $equipe_gagnante . " " . $points_equipe_1. " " . $points_equipe_2);

$bdd->exec(' UPDATE etat_partie  SET Etat = 3 WHERE id = 1');//Change l'état de la partie à "Fin partie"
//Enregistre timestamp fin partie

//le nombre de secondes depuis le 1er Janvier 1970 à 00:00:00 UTC
$time = strtotime("now");
$req = $bdd->prepare('UPDATE etat_partie SET Etat = :Time WHERE id = 19');
$req->execute(array( 'Time' => $time ));
} // gagne_Partie

function JoueCartes($Tour_joueur, $count_tour, $carte, $bdd) {
//============================================================
//Joue la carte
$req = $bdd->prepare('UPDATE cartes_jouees SET Joueur = :Joueur , ID_cartes = :ID_cartes  WHERE id = :id');
$req->execute(array(
'Joueur' => $Tour_joueur ,
'id' => $count_tour ,
'ID_cartes' => $carte  ));
$req->closeCursor();     
$req = $bdd->prepare('UPDATE cartes_partie1 SET Joueur = 0 WHERE id = ?');
$req->execute(array($carte));
$req->closeCursor();
                    
$count_tour++;
$new_Tour_joueur = $Tour_joueur + 1;

if($new_Tour_joueur == 5) { $new_Tour_joueur =1;}

$req = $bdd->prepare('UPDATE etat_partie SET Etat = ? WHERE id = ?');
Commande("CARTE_JOUEE " . $Tour_joueur . " " . $carte);

if ($count_tour == 5) { //Plie terminée
  $new_count_tour = 1; 
  }
else {$new_count_tour =$count_tour; }

$req->execute(array( $new_count_tour, 8));
$req->execute(array( $new_Tour_joueur, 4));
$req->closeCursor();
 echo "1";
if ($count_tour != 5) { Commande( "TOUR " . $new_Tour_joueur); }

if ($count_tour == 5) { //Plie terminée -> Compte_points
  Compte_points($bdd);
  }
} //JoueCartes

function TempsDerniereAction ($bdd) {
//===================================
// Met à jour le temps de la dernière action
 
// le nombre de secondes depuis le 1er Janvier 1970 à 00:00:00 UTC
$time = strtotime("now");
    
$req = $bdd->prepare('UPDATE etat_partie SET Etat = :Time WHERE id = 18');
$req->execute(array( 'Time' => $time ));
} // TempsDerniereAction

function ResetPartie($bdd) {
//==========================
//Remet à zéro le jeu

$req = $bdd->prepare('UPDATE etat_partie SET Etat = ? '); 
$req->execute(array(0));
$req->closeCursor();
$req = $bdd->prepare('UPDATE etat_partie SET Etat = ? WHERE id < 5'); 
$req->execute(array(1));
$req->closeCursor();
$req = $bdd->exec('UPDATE etat_partie SET Etat = 1 WHERE id = 8'); 
//Supprime toutes les commandes
$req = $bdd->exec('TRUNCATE TABLE commandes');
} // ResetPartie

function VerifieTemps($bdd) {
//===========================
//Vérifie que la dernière action a eu lieu il y a moins de 2 minutes

$reponse = $bdd->query('SELECT Etat FROM etat_partie WHERE id = 18 ');
$Temps = $reponse->fetch()['Etat'];

$diffTemps = strtotime("now") - $Temps;
if($diffTemps >= 120 AND $diffTemps < 315360000) {
  ResetPartie($bdd);
  }
} // VerifieTemps

//###############################  DEBUT  ############################


try {
  // On se connecte à MySQL
  if (gethostbyaddr($_SERVER['REMOTE_ADDR']) == 'localhost') {
    $bdd = new PDO('mysql:host=localhost;dbname=jass;charset=utf8','root','',array(PDO::ATTR_ERRMODE => PDO::ERRMODE_EXCEPTION));
    }
  else {
    $bdd = new PDO('mysql:host=borj.myd.infomaniak.com;dbname=borj_jass;charset=utf8','borj_sebastien','LE VOTRE',array(PDO::ATTR_ERRMODE => PDO::ERRMODE_EXCEPTION));
    }
  }
catch(Exception $e) {
  // En cas d'erreur, on affiche un message et on arrête tout
  die('Erreur : '.$e->getMessage());
  }

$reponse = $bdd->query('SELECT Etat FROM etat_partie WHERE id = 1 ');
$partie = $reponse->fetch()['Etat'];
$reponse->closeCursor();
  

if ($partie == 1) { // Prépare la partie
  if (isset($_GET['choix_joueur'])) {
    if ($_GET['choix_joueur']>=1 AND $_GET['choix_joueur']<=4) {
      $choix_joueur = intval($_GET['choix_joueur']);
      $req = $bdd->prepare('SELECT Etat FROM etat_partie WHERE id = ? ');
      $req->execute(array($choix_joueur + 10));
      $choix_joueur_bdd= $req->fetch()['Etat']; // Lit dans la base de données l'état (0 ou 1) du joueur. 1 => déjà choisi
      $req->execute(array(15));
      $nombre_joueurs = $req->fetch()['Etat']; // Lit le nombre de joueurs
      $req->closeCursor();
     // echo $choix_joueur_bdd;
      if ($choix_joueur_bdd == 0) { // Nouveau joueur
        echo "1";
        $nombre_joueurs++;
        $req = $bdd->prepare('UPDATE etat_partie SET Etat = ? WHERE id = ?');
        $req->execute(array( 1, $choix_joueur + 10)); // Ecrit dans la BDD que le joueur est choisi
        $req->execute(array( $nombre_joueurs, 15));   // Ecrit dans la BDD le nombre de joueurs
        if ($nombre_joueurs == 4) {$req->execute(array( 2, 1));} // Passe en Phase 1 du jeux. (2 == Nbr_phases)
        $req->closeCursor();
        //Commandes
        Commande("JOIN " . $choix_joueur); // Ecrit "JOINx" dans la BDD, où x est le numéro du joueur.
        if ($nombre_joueurs == 4) {Commande("START");}
        }
      else if ($choix_joueur_bdd == 1) {
        echo "Joueur dejà choisi!";
        }
      }
    }
  } // if ($partie == 1) { // Prépare la partie

if ($partie == 2) { // Lance partie
    $reponse = $bdd->query('SELECT Etat FROM etat_partie WHERE id = 3 ');
    $phase = $reponse->fetch()['Etat'];
    $reponse->closeCursor();
    
    if($phase ==1) { //Distribue les cartes
      
      $bdd->exec(' UPDATE etat_partie  SET Etat = 2 WHERE id = 3');
      for ($i=1; $i<=36; $i++){ //Crée un tableau contenant les cartes
      $tableau[] = $i;
      }
      shuffle($tableau);  //mélange le tableau
      $req = $bdd->prepare('UPDATE cartes_partie1 SET Joueur = :joueur WHERE id = :id');
      $z=0;
      
      for ($ii=1; $ii <=4; $ii++) { //Distribue les cartes dans la BDD
        
        for ($i=0; $i<=8;$i++) {
        //echo $i, "  ", $tableau[$i], "<br>";
        $req->execute(array(
          'id' => $tableau[$z] ,
        'joueur' => $ii  ));
        $z++;
        }
      }
    $req->closeCursor();
    //récupère numéro match
    $reponse = $bdd->query('SELECT Etat FROM etat_partie WHERE id = 2 ');
    $nbr_match = $reponse->fetch()['Etat'];
    
    if($nbr_match == 1) { //Si premier match -> Joueur qui a 7 de carreau fait atout
      
      $reponse = $bdd->query('SELECT joueur FROM cartes_partie1 WHERE id = 20 ');
      $joueur_atout = $reponse->fetch()['joueur'];
      
      //Met à jour le joueur qui fait l'atout
      $req = $bdd->prepare('UPDATE etat_partie SET Etat = :Etat WHERE id = 5 OR id = 4 ');
      $req->execute(array( 'Etat' => $joueur_atout ));
    }
    
        //Commande
        $reponse = $bdd->prepare('SELECT Etat FROM etat_partie WHERE id = ? ');
        $reponse->execute(array(5));
        $joueur_atout = $reponse->fetch()['Etat']; //joueur qui fait atout
        Commande("MATCH ". $nbr_match);
        Commande( "CHOIX_ATOUT " . $joueur_atout);
    }
    
    else if ($phase ==2) { //Choisit l'atout
      
      if (isset($_GET['joueur']) AND isset($_GET['atout'])) { //Si les champs joueur et atout existent
        
        $reponse = $bdd->query('SELECT Etat FROM etat_partie WHERE id = 5 ');
        $joueur_atout = $reponse->fetch()['Etat']; //Joueur qui fait atout
        $reponse->closeCursor();
        $atout = intval($_GET['atout']); //atout choisi
        $req = $bdd->query('SELECT Etat FROM etat_partie WHERE id = 17 ');
        $joueur_chibre = $req->fetch()['Etat']; //Si un joueur chibre, contient l'id du joueur qui choisit l'atout
        $req->closeCursor();
         //Vérifie que c'est le bon joueur et que l'atout est compris entre 1 et 4
        if (($_GET['joueur'] == $joueur_atout OR $_GET['joueur'] == $joueur_chibre) AND $atout >=1 AND $atout <= 4) {
          $req = $bdd->prepare('UPDATE etat_partie SET Etat = :etat WHERE id = :id');
          $req->execute(array( 'id' => 6 , 'etat' => $atout  )); //Met à jour l'atout
          $bdd->exec('UPDATE etat_partie SET Etat = 3 WHERE id = 3'); //Passe en phase de jeu
          $bdd->exec('UPDATE etat_partie SET Etat = 0 WHERE id = 17'); //Remet à zéro le joueur qui chibre
          //Commande
          Commande("ATOUT " .  $atout);
          $reponse = $bdd->prepare('SELECT Etat FROM etat_partie WHERE id = ? ');
          $reponse->execute(array(4));
          $tour_joueur = $reponse->fetch()['Etat'];
          $reponse->closeCursor();

          //Calcule les annonces
          Annonce($bdd);

          Commande("PLIE 1");
          Commande("TOUR " . $tour_joueur);
          }
        else if ($_GET['joueur'] == $joueur_atout AND  $atout == 5) { //Si le joueur chibre
          $joueur_chibre = $joueur_atout + 2; //Son partenaire peut choisir l'atout
            if ($joueur_chibre > 4) {
              $joueur_chibre -= 4;
              }
            $req = $bdd->prepare('UPDATE etat_partie SET Etat = :etat WHERE id = :id');
          $req->execute(array( 'id' => 17 , 'etat' => $joueur_chibre  ));
          Commande("CHIBRE " . $joueur_atout . " " . $joueur_chibre);
          }

        TempsDerniereAction($bdd);
        }
      }

    else if ($phase ==3) { //Phase de jeu
      if (isset($_GET['joueur']) AND isset($_GET['carte'])) { //Vérifie que les champs joueur et carte existent
        $carte = intval($_GET['carte']);
        $reponse = $bdd->query('SELECT Etat FROM etat_partie WHERE id = 4 ');
        $Tour_joueur = $reponse->fetch()['Etat']; //Récupère le numéro du joueur qui doit jouer
        $reponse->closeCursor();

        if ($_GET['joueur'] == $Tour_joueur AND $carte >=1 AND $carte <= 36) { //Vérifie que c'est le tour du joueur

          $req = $bdd->prepare('SELECT Joueur FROM cartes_partie1 WHERE id = ?');
          $req->execute(array($carte));

          if ($req->fetch()['Joueur'] == $Tour_joueur ) { //Vérifie que la carte appartient au joueur
          $req->closeCursor();

          //Vérifie si le joueur a le droit de jouer la carte

          $req = $bdd->query('SELECT Etat FROM etat_partie WHERE id = 6');

          $atout = $req->fetch()['Etat'];
          $req->closeCursor();
          $req= $bdd->prepare('SELECT id FROM cartes_partie1 WHERE Joueur = ?');
          $req->execute(array($Tour_joueur));
          $coeur = 0;
          $pique =0;
          $carreau =0;
          $trefle =0;
          //Compte le nombre de cartes de chaque couleur (sauf valet d'atout, qui peut être joué n'importe quand)
          foreach ($req as $value) {
            $cartes = $value[0];

            if ($cartes >= 1 AND $cartes <=9) { // Coeurs
              if ($cartes != 6) { $coeur++; } // 6 == Valet de coeur
              else { //Si c'est un valet
                if ($atout != 1) { //Si ce n'est pas le valet d'atout
                  $coeur++;
                  }
                }
              }
            if ($cartes >= 10 AND $cartes <= 18) { // Pique
              if ($cartes != 15) { $pique++; } // 15 == Valet de pique
              else { //Si c'est un valet
                if ($atout != 2) { //Si ce n'est pas le valet d'atout
                  $pique++;
                  }
                }
              }
            if ($cartes >= 19 AND $cartes <= 27) { // Carreau
              if ($cartes != 24) { $carreau++; } // 24 == Valet de carreau
              else { //Si c'est un valet
                if ($atout != 3) { //Si ce n'est pas le valet d'atout
                  $carreau++;
                  }
                }
              }
            if ($cartes >= 28 AND $cartes <= 36) { // Trefle
              if ($cartes != 33) { // 33 == Valet de trefle
                $trefle++;
                }
              else { //Si c'est un valet
                if ($atout != 4) { //Si ce n'est pas le valet d'atout
                  $trefle++;
                  }
                }
              }
            } // foreach

          $req->closeCursor();

          $reponse = $bdd->query('SELECT Etat FROM etat_partie WHERE id = 8 ');//Recupère l'avancement du tour
          $count_tour = $reponse->fetch()['Etat'];
          $reponse->closeCursor();
          $reponse = $bdd->query('SELECT Etat FROM etat_partie WHERE id = 7 ');//Recupère la couleur du tour
          $couleurTour = $reponse->fetch()['Etat'];
          $reponse->closeCursor();
          //Récupère couleur carte jouée
          $reponse = $bdd->prepare('SELECT couleur FROM cartes_partie1 WHERE id = ? ');
          $reponse->execute(array($carte));
          $couleur = $reponse->fetch()['couleur'];
          $reponse->closeCursor();
          if($couleur=='Coeur') { $couleurCarte = 1;}
          else if($couleur=='Pique') { $couleurCarte = 2;}
          else if($couleur=='Carreau') { $couleurCarte = 3;}
          else if($couleur=='Trèfle') { $couleurCarte = 4;}
          //echo "hello";
          if ($count_tour ==1) { //Si c'est le premier tour, il peut joueur n'importe quelle carte
            JoueCartes($Tour_joueur, $count_tour, $carte,$bdd);
            //Met à jour la couleur du tour
            $req = $bdd->prepare('UPDATE etat_partie SET Etat = ? WHERE id = 7');
            $req->execute(array( $couleurCarte));
            $req->closeCursor();
            //  echo "premiertour";
            }
          else if ($couleurTour == $couleurCarte){ //Si la carte jouée est de la bonne couleur
            JoueCartes($Tour_joueur, $count_tour, $carte,$bdd);
            //  echo "bonne couleur";
            }
          else {//Si la carte jouée n'est pas de la bonne couleur
            if ($couleurCarte == $atout) { //Si c'est un atout
              JoueCartes($Tour_joueur, $count_tour, $carte, $bdd);
              echo " atout";
              }
            else if ($couleurTour == 1 AND $coeur == 0) {
              JoueCartes($Tour_joueur, $count_tour, $carte,$bdd);
              echo " coeur";
              }
            else if ($couleurTour == 2 AND $pique == 0) {
              JoueCartes($Tour_joueur, $count_tour, $carte,$bdd);
              echo " pique";
              }
            else if ($couleurTour == 3 AND $carreau == 0) {
              JoueCartes($Tour_joueur, $count_tour, $carte,$bdd);
              echo " carreau";
            }
            else if ($couleurTour == 4 AND $trefle == 0) {
              JoueCartes($Tour_joueur, $count_tour, $carte,$bdd);
              echo " trefle";
              }

            echo "mauvaise couleur";
            }

          TempsDerniereAction($bdd);
          }
        }
      }
    }
  VerifieTemps($bdd);

  } // if ($partie == 2) { // Lance partie
  
if ($partie == 3) { //Termine la partie
  //Garde les données disponibles pendant 1 minute avant de remettre à zéro
  $reponse = $bdd->query('SELECT Etat FROM etat_partie WHERE id = 19 ');
  $Temps = $reponse->fetch()['Etat'];
  if(strtotime("now") - $Temps >= 60) { ResetPartie($bdd); }
  }

if (isset($_GET['cartes_joueur'])) { //Gère les requêtes de distribution des cartes
  if ($_GET['cartes_joueur']>= 1 AND $_GET['cartes_joueur'] <=4) {
    $joueur = intval($_GET['cartes_joueur']);
    $req= $bdd->prepare('SELECT id FROM cartes_partie1 WHERE Joueur = ? ');
    $req->execute(array($joueur));

    foreach($req as $value) { echo $value['id'], " "; }
    }
  }
    
?>


