-- phpMyAdmin SQL Dump
-- version 4.9.6
-- https://www.phpmyadmin.net/
--
-- Hôte : borj.myd.infomaniak.com
-- Généré le :  mar. 26 avr. 2022 à 13:41
-- Version du serveur :  5.6.50-log
-- Version de PHP :  7.4.28

SET SQL_MODE = "NO_AUTO_VALUE_ON_ZERO";
SET AUTOCOMMIT = 0;
START TRANSACTION;
SET time_zone = "+00:00";


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8mb4 */;

--
-- Base de données :  `borj_jass`
--

-- --------------------------------------------------------

--
-- Structure de la table `cartes_jouees`
--

CREATE TABLE `cartes_jouees` (
  `id` int(11) NOT NULL,
  `ID_cartes` int(11) NOT NULL,
  `Joueur` int(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

--
-- Déchargement des données de la table `cartes_jouees`
--

INSERT INTO `cartes_jouees` (`id`, `ID_cartes`, `Joueur`) VALUES
(1, 20, 1),
(2, 13, 2),
(3, 12, 3),
(4, 2, 4);

-- --------------------------------------------------------

--
-- Structure de la table `cartes_partie1`
--

CREATE TABLE `cartes_partie1` (
  `id` int(11) NOT NULL,
  `nom` char(20) NOT NULL,
  `type` char(11) NOT NULL,
  `couleur` char(11) NOT NULL,
  `power` int(11) NOT NULL,
  `Joueur` int(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

--
-- Déchargement des données de la table `cartes_partie1`
--

INSERT INTO `cartes_partie1` (`id`, `nom`, `type`, `couleur`, `power`, `Joueur`) VALUES
(1, 'Six de coeur', 'Six', 'Coeur', 1, 2),
(2, 'Sept de coeur', 'Sept', 'Coeur', 2, 4),
(3, 'Huit de coeur', 'Huit', 'Coeur', 3, 1),
(4, 'Neuf de coeur', 'Neuf', 'Coeur', 4, 2),
(5, 'Dix de coeur', 'Dix', 'Coeur', 5, 2),
(6, 'Valet de coeur', 'Valet', 'Coeur', 6, 1),
(7, 'Dame de coeur', 'Dame', 'Coeur', 7, 3),
(8, 'Roi de coeur', 'Roi', 'Coeur', 8, 4),
(9, 'As de coeur', 'As', 'Coeur', 9, 2),
(10, 'Six de pique', 'Six', 'Pique', 1, 4),
(11, 'Sept de pique', 'Sept', 'Pique', 2, 3),
(12, 'Huit de pique', 'Huit', 'Pique', 3, 1),
(13, 'Neuf de pique', 'Neuf', 'Pique', 4, 2),
(14, 'Dix de pique', 'Dix', 'Pique', 5, 3),
(15, 'Valet de pique', 'Valet', 'Pique', 6, 1),
(16, 'Dame de pique', 'Dame', 'Pique', 7, 2),
(17, 'Roi de pique', 'Roi', 'Pique', 8, 3),
(18, 'As de pique', 'As', 'Pique', 9, 4),
(19, 'Six de carreau', 'Six', 'Carreau', 1, 4),
(20, 'Sept de carreau', 'Sept', 'Carreau', 2, 3),
(21, 'Huit de carreau', 'Huit', 'Carreau', 3, 1),
(22, 'Neuf de carreau', 'Neuf', 'Carreau', 4, 4),
(23, 'Dix de carreau', 'Dix', 'Carreau', 5, 1),
(24, 'Valet de carreau', 'Valet', 'Carreau', 6, 1),
(25, 'Dame de carreau', 'Dame', 'Carreau', 7, 3),
(26, 'Roi de carreau', 'Roi', 'Carreau', 8, 3),
(27, 'As de carreau', 'As', 'Carreau', 9, 4),
(28, 'Six de trèfle', 'Six', 'Trèfle', 1, 1),
(29, 'Sept de trèfle', 'Sept', 'Trèfle', 2, 2),
(30, 'Huit de trèfle', 'Huit', 'Trèfle', 3, 2),
(31, 'Neuf de trèfle', 'Neuf', 'Trèfle', 4, 1),
(32, 'Dix de trèfle', 'Dix', 'Trèfle', 5, 3),
(33, 'Valet de trèfle', 'Valet', 'Trèfle', 6, 3),
(34, 'Dame de trèfle', 'Dame', 'Trèfle', 7, 4),
(35, 'Roi de trèfle', 'Roi', 'Trèfle', 8, 2),
(36, 'As de trèfle', 'As', 'Trèfle', 9, 4);

-- --------------------------------------------------------

--
-- Structure de la table `commandes`
--

CREATE TABLE `commandes` (
  `ID` int(11) NOT NULL,
  `Timestamp` datetime NOT NULL,
  `Commande` varchar(256) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- --------------------------------------------------------

--
-- Structure de la table `etat_partie`
--

CREATE TABLE `etat_partie` (
  `id` int(11) NOT NULL,
  `Type` varchar(20) NOT NULL,
  `Etat` int(1) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

--
-- Déchargement des données de la table `etat_partie`
--

INSERT INTO `etat_partie` (`id`, `Type`, `Etat`) VALUES
(1, 'Partie', 1),
(2, 'Nbr_phases', 1),
(3, 'Phases', 1),
(4, 'Tour_joueur', 1),
(5, 'Joueur_atout', 1),
(6, 'Couleur_atout', 0),
(7, 'Couleur_tour', 0),
(8, 'Tour_joueur_count', 1),
(9, 'Points_equipe1', 0),
(10, 'Points_equipe2', 0),
(11, 'Joueur1_OK', 0),
(12, 'Joueur2_OK', 0),
(13, 'Joueur3_OK', 0),
(14, 'Joueur4_OK', 0),
(15, 'Joueurs_OK', 0),
(16, 'Nombre_plies', 0),
(17, 'Chibre', 0),
(18, 'TempsDerniereAction', 0),
(19, 'TempsFinPartie', 0);

-- --------------------------------------------------------

--
-- Structure de la table `propriétés`
--

CREATE TABLE `propriétés` (
  `id` int(11) NOT NULL,
  `nom` char(20) NOT NULL,
  `type` char(11) NOT NULL,
  `couleur` char(11) NOT NULL,
  `power` int(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

--
-- Déchargement des données de la table `propriétés`
--

INSERT INTO `propriétés` (`id`, `nom`, `type`, `couleur`, `power`) VALUES
(1, 'Six de coeur', 'Six', 'Coeur', 1),
(2, 'Sept de coeur', 'Sept', 'Coeur', 2),
(3, 'Huit de coeur', 'Huit', 'Coeur', 3),
(4, 'Neuf de coeur', 'Neuf', 'Coeur', 4),
(5, 'Dix de coeur', 'Dix', 'Coeur', 5),
(6, 'Valet de coeur', 'Valet', 'Coeur', 6),
(7, 'Dame de coeur', 'Dame', 'Coeur', 7),
(8, 'Roi de coeur', 'Roi', 'Coeur', 8),
(9, 'As de coeur', 'As', 'Coeur', 9),
(10, 'Six de pique', 'Six', 'Pique', 1),
(11, 'Sept de pique', 'Sept', 'Pique', 2),
(12, 'Huit de pique', 'Huit', 'Pique', 3),
(13, 'Neuf de pique', 'Neuf', 'Pique', 4),
(14, 'Dix de pique', 'Dix', 'Pique', 5),
(15, 'Valet de pique', 'Valet', 'Pique', 6),
(16, 'Dame de pique', 'Dame', 'Pique', 7),
(17, 'Roi de pique', 'Roi', 'Pique', 8),
(18, 'As de pique', 'As', 'Pique', 9),
(19, 'Six de carreau', 'Six', 'Carreau', 1),
(20, 'Sept de carreau', 'Sept', 'Carreau', 2),
(21, 'Huit de carreau', 'Huit', 'Carreau', 3),
(22, 'Neuf de carreau', 'Neuf', 'Carreau', 4),
(23, 'Dix de carreau', 'Dix', 'Carreau', 5),
(24, 'Valet de carreau', 'Valet', 'Carreau', 6),
(25, 'Dame de carreau', 'Dame', 'Carreau', 7),
(26, 'Roi de carreau', 'Roi', 'Carreau', 8),
(27, 'As de carreau', 'As', 'Carreau', 9),
(28, 'Six de trèfle', 'Six', 'Trèfle', 1),
(29, 'Sept de trèfle', 'Sept', 'Trèfle', 2),
(30, 'Huit de trèfle', 'Huit', 'Trèfle', 3),
(31, 'Neuf de trèfle', 'Neuf', 'Trèfle', 4),
(32, 'Dix de trèfle', 'Dix', 'Trèfle', 5),
(33, 'Valet de trèfle', 'Valet', 'Trèfle', 6),
(34, 'Dame de trèfle', 'Dame', 'Trèfle', 7),
(35, 'Roi de trèfle', 'Roi', 'Trèfle', 8),
(36, 'As de trèfle', 'As', 'Trèfle', 9);

-- --------------------------------------------------------

--
-- Structure de la table `temps`
--

CREATE TABLE `temps` (
  `Temps` datetime NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

--
-- Déchargement des données de la table `temps`
--

INSERT INTO `temps` (`Temps`) VALUES
('2015-11-21 16:40:04');

--
-- Index pour les tables déchargées
--

--
-- Index pour la table `cartes_jouees`
--
ALTER TABLE `cartes_jouees`
  ADD PRIMARY KEY (`id`);

--
-- Index pour la table `cartes_partie1`
--
ALTER TABLE `cartes_partie1`
  ADD PRIMARY KEY (`id`);

--
-- Index pour la table `commandes`
--
ALTER TABLE `commandes`
  ADD PRIMARY KEY (`ID`);

--
-- Index pour la table `etat_partie`
--
ALTER TABLE `etat_partie`
  ADD PRIMARY KEY (`id`);

--
-- Index pour la table `propriétés`
--
ALTER TABLE `propriétés`
  ADD PRIMARY KEY (`id`) USING BTREE;

--
-- AUTO_INCREMENT pour les tables déchargées
--

--
-- AUTO_INCREMENT pour la table `cartes_jouees`
--
ALTER TABLE `cartes_jouees`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=5;

--
-- AUTO_INCREMENT pour la table `cartes_partie1`
--
ALTER TABLE `cartes_partie1`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=37;

--
-- AUTO_INCREMENT pour la table `commandes`
--
ALTER TABLE `commandes`
  MODIFY `ID` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=8;

--
-- AUTO_INCREMENT pour la table `etat_partie`
--
ALTER TABLE `etat_partie`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=20;

--
-- AUTO_INCREMENT pour la table `propriétés`
--
ALTER TABLE `propriétés`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=37;
COMMIT;

/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
